Attribute VB_Name = "modFileSave"
Option Explicit

Public Enum SegmentEnum
  afwFilePath = 1
  afwFileName = 2
  afwFileExtension = 3
  afwPathNameSansExtension = 4
  afwFullFileName = 5
End Enum

Private Type OpenFilename
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Const OFN_READONLY = &H1
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_SHOWHELP = &H10
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOLONGNAMES = &H40000                      '  force no long names for 4.x modules
Public Const OFN_EXPLORER = &H80000                         '  new look commdlg
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_LONGNAMES = &H200000                       '  force long names for 3.x modules

Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFilename) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFilename) As Long

Public gsComDlgInitDir As String

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" _
                              (ByVal lpszPath As String, _
                               ByVal lpPrefixString As String, _
                               ByVal wUnique As Long, _
                               ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" _
                              (ByVal nBufferLength As Long, _
                               ByVal lpBuffer As String) As Long

Function SaveDialog(Form1 As Form, Filter As String, Title As String, _
                    Optional InitDir As String, Optional flags As Long _
                    = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_CREATEPROMPT, Optional _
                    sDefFile As String = "*.csv") As String

Dim ofn As OpenFilename
Dim A As Long
  ofn.lStructSize = Len(ofn)
  ofn.hwndOwner = Form1.hWnd
  ofn.hInstance = App.hInstance
  If Right$(Filter, 1) <> "|" Then Filter = Filter + "|"
  For A = 1 To Len(Filter)
        If Mid$(Filter, A, 1) = "|" Then
            Mid$(Filter, A, 1) = Chr$(0)
        End If
  Next
  ofn.lpstrFilter = Filter
  ofn.lpstrFile = sDefFile & Space$(249)
  'ofn.lpstrFile = Space$(254)
  ofn.nMaxFile = 255
  ofn.lpstrFileTitle = Space$(254)
  ofn.nMaxFileTitle = 255
  If Trim$(InitDir) <> "" Then
    gsComDlgInitDir = InitDir
  ElseIf Trim$(gsComDlgInitDir) = "" Then
    gsComDlgInitDir = App.Path
  End If
  ofn.lpstrInitialDir = gsComDlgInitDir
  ofn.lpstrTitle = Title
  ofn.flags = flags
  A = GetSaveFileName(ofn)

  If (A) Then
    SaveDialog = Replace(Trim$(ofn.lpstrFile), Chr(0), "")
    gsComDlgInitDir = SegmentFileName(Trim$(ofn.lpstrFile), afwFilePath)
  Else
    SaveDialog = ""
  End If

End Function

Function OpenDialog(Form1 As Form, Filter As String, Title As String, _
                    Optional InitDir As String, _
                    Optional flags As Long = OFN_FILEMUSTEXIST, _
                    Optional bMultiSelect As Boolean = False) As String

Dim ofn As OpenFilename
Dim A As Long
  ofn.lStructSize = Len(ofn)
  ofn.hwndOwner = Form1.hWnd
  ofn.hInstance = App.hInstance
  If Right$(Filter, 1) <> "|" Then Filter = Filter + "|"
  For A = 1 To Len(Filter)
      If Mid$(Filter, A, 1) = "|" Then Mid$(Filter, A, 1) = Chr$(0)
  Next
  ofn.lpstrFilter = Filter
  ofn.lpstrFile = Space$(254)
  ofn.nMaxFile = 255
  ofn.lpstrFileTitle = Space$(254)
  ofn.nMaxFileTitle = 255
  If Trim$(InitDir) <> "" Then
    gsComDlgInitDir = InitDir
  ElseIf Trim$(gsComDlgInitDir) = "" Then
    gsComDlgInitDir = App.Path
  End If
  ofn.lpstrInitialDir = gsComDlgInitDir
  ofn.lpstrTitle = Title
  'If Not IsMissing(Flags) Then
  '  If TypeName(Flags) = "Long" Then ofn.Flags = Flags
  'Else
  '  ofn.Flags = OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST
  'End If
  ofn.flags = flags Or OFN_EXPLORER
  If bMultiSelect Then ofn.flags = ofn.flags Or OFN_ALLOWMULTISELECT
  
  A = GetOpenFileName(ofn)

  If (A) Then
    If InStr(ofn.lpstrFile, Chr$(0)) And Not bMultiSelect Then
      ofn.lpstrFile = Left$(ofn.lpstrFile, InStr(ofn.lpstrFile, Chr$(0)) - 1)
    End If
    OpenDialog = Trim$(ofn.lpstrFile)
    If Not bMultiSelect Then gsComDlgInitDir = SegmentFileName(Trim$(ofn.lpstrFile), afwFilePath)
  Else
    OpenDialog = ""
  End If

End Function

Public Function FileExists(fName As String) As Boolean
Dim fnum
On Error Resume Next
  fnum = FreeFile
  Open fName For Input As fnum
  If Err <> 0 Then
    FileExists = False
  Else
    FileExists = True
  End If
  Close #fnum
End Function

Public Sub MakeDirectory(ThisDirectory As String)
  Dim Length          As Integer
  Dim DirectoryLength As Integer
  Dim NewDirectory    As String

  Length = 4

  'add "\" To directory if not already there. -----
  If Right(ThisDirectory, 1) <> "\" Then
    ThisDirectory = ThisDirectory + "\"
  End If

  'create nested directory ---------
  While Not DirectoryExists(ThisDirectory)
    DirectoryLength = InStr(Length, ThisDirectory, "\")
    
    If Not DirectoryExists(Left(ThisDirectory, DirectoryLength)) Then
      MkDir Left(ThisDirectory, DirectoryLength - 1)
    End If
    
    Length = DirectoryLength + 1
  Wend
End Sub

'--------------------------------------------------------------------------
'<Purpose>
'   This function is used to validate if a directory already exists.
'<Syntax>
'   DirectoryExists(ByVal ThisDirectory)
'
'   Part                Description
'   ------------------  ---------------------------------------------------
'   ThisDirectory       Required. Drive\Path to directory to validate.
'<Remarks>
'   Returns 'True' if directory exists, otherwise 'False'.
'--------------------------------------------------------------------------
Public Function DirectoryExists(ByVal ThisDirectory As String) As Boolean
  Dim DirectoryFound As String
  Const afwPathNotFound As Integer = 76

  On Local Error GoTo 0
  DirectoryFound = Dir(ThisDirectory, vbDirectory)
  If (Len(DirectoryFound) = 0 Or Err = afwPathNotFound) Then
    DirectoryExists = False
  Else
    DirectoryExists = True
  End If
End Function

'--------------------------------------------------------------------------
'<Purpose>
'   This function will shorten a directory name to the length passed to it.
'<Syntax>
'   DirectoryFixUp(ByVal ThisDirectory, ByVal MaxLength)
'
'   Part                Description
'   ------------------  ---------------------------------------------------
'   ThisDirectory       Required. Drive\Path to directory to fixup.
'   MaxLength           Required. Maximum length of the string to return.
'<Remarks>
'   Returns fixed up directory string.  If directory length is less than
'   'MaxLength' then complete directory string is returned.  If
'   intermediate fixed up directory string (i.e. "C:\...\filename.ext") is
'   larger than 'MaxLength' the return string is an empty string ("").
'   If 'MaxLength' is greater than intermediate fixed up string then return
'   as many directories as possible leading to target file.
'
'   Function assumes drive specifier is first part of 'ThisDirectory' (i.e.
'   C:\).
'
'   This procedure requires the inclusion of the function(s):
'       DirectoryExists()
'--------------------------------------------------------------------------
Public Function DirectoryFixUp(ByVal ThisDirectory As String, _
                               ByVal MaxLength As Integer) As String
    Dim i                    As Integer
    Dim LastBackSlashFoundAt As Integer
    
    
    'show complete directory if possible -----------
    If Len(ThisDirectory) <= MaxLength Then
        DirectoryFixUp = ThisDirectory
        Exit Function
    End If

    'search backward for first backslash -----
    For i = Len(ThisDirectory) To 0 Step -1
        If Mid(ThisDirectory, i, 1) = "\" Then
            Exit For
        End If
    Next

    'build a intermediate copy of the directory ---------
    DirectoryFixUp = Left(ThisDirectory, 3) & "..." & _
                     Right(ThisDirectory, Len(ThisDirectory) - (i - 1))
    
    'if intermediate fixup is longer than maximum length then return
    'empty string to denote that function failed.
    If (Len(DirectoryFixUp) > MaxLength) Then
        DirectoryFixUp = ""
        Exit Function
    End If
    
    'show as many directories as possible in the space allowed ---------
    For i = 1 To Len(ThisDirectory)
        If Mid(ThisDirectory, i, 1) = "\" Then
            If (Len(Left(ThisDirectory, i)) + Len("...") + Len(DirectoryFixUp) - 6 > MaxLength) Then
                Exit For
            End If
            LastBackSlashFoundAt = i
        End If
    Next
    
    If (LastBackSlashFoundAt = 0) Then
        'use intermediate build of directory fixup --------
        Exit Function
    Else
        DirectoryFixUp = Left(ThisDirectory, LastBackSlashFoundAt) & "..." & _
                         Right(DirectoryFixUp, Len(DirectoryFixUp) - 6)
    End If

End Function

Public Function GetTempName() As String
Dim tmpDir As String, tmpName As String
On Error Resume Next
  tmpDir = Space$(255)
  Call GetTempPath(255, tmpDir)
  tmpDir = Left$(tmpDir, InStr(tmpDir, Chr$(0)) - 1)
  tmpName = Space$(255)
  Call GetTempFileName(tmpDir, "~ar", 0, tmpName)
  tmpName = Left$(tmpName, InStr(tmpName, Chr$(0)) - 1)
  GetTempName = tmpName
End Function

Function MoveFile(sSrc As String, sDest As String) As Integer
Dim msg As String
'move file from sSrc --> to sDest
  On Error Resume Next
    Err = 0
    If FileExists(sDest) Then
      Err = 0
      Kill sDest
      If Err <> 0 Then
        MoveFile = Err
        Exit Function
      End If
    End If
    Err = 0
    If Not DirectoryExists(SegmentFileName(sDest, afwFilePath)) Then
      Call MakeDirectory(SegmentFileName(sDest, afwFilePath))
    End If
    Name sSrc As sDest
    If Err <> 0 Then
      MoveFile = Err
      Exit Function
    End If
    MoveFile = 0
End Function

Function CopyFile(sSrc As String, sDest As String) As Integer
Dim msg As String
'copy file from sSrc --> to sDest
  On Error Resume Next
    Err = 0
    If FileExists(sDest) Then
      Err = 0
      Kill sDest
      If Err <> 0 Then
        CopyFile = Err
        Exit Function
      End If
    End If
    Err = 0
    If Not DirectoryExists(SegmentFileName(sDest, afwFilePath)) Then
      Call MakeDirectory(SegmentFileName(sDest, afwFilePath))
    End If
    FileCopy sSrc, sDest
    If Err <> 0 Then
      CopyFile = Err
      Exit Function
    End If
    CopyFile = 0
End Function




'=============================================================================================
Public Function SegmentFileName(ByVal FileName As String, Action As SegmentEnum) As String
'--------------------------------------------------------------------------------------
'   Constant                        Value   Description
'   ------------------------  ------  ---------------------------------------------------
'   afwFilePath                      1       Returns Drive/Path,
'   afwFilename                     2       Returns filename w/o extension,
'   afwFileExtension              3       Returns extenstion ONLY,
'   afwPathNameSansExt       4       Returns Drive/Path/Filename w/o extension,
'   afwFullFileName              5       Returns full filename w/extension
'---------------------------------------------------------------------------------------

     Dim CharPos     As Integer
     Dim LenFileName As Integer
    
     LenFileName = Len(FileName)
     Select Case Action
     Case afwFilePath
             For CharPos = LenFileName To 1 Step -1
                 If (Mid(FileName, CharPos, 1) = "\") Then
                     SegmentFileName = Left(FileName, CharPos)
                     Exit Function
                 End If
             Next
            
     Case afwFileName, afwFullFileName
             For CharPos = LenFileName To 1 Step -1
                 If (Mid(FileName, CharPos, 1) = "\") Then
                     FileName = Mid(FileName, CharPos + 1)
                     Exit For
                 End If
             Next
             If (Action = afwFileName) Then
                 CharPos = InStr(FileName, ".")
                 If (CharPos > 0) Then FileName = Left(FileName, CharPos - 1)
             End If
             SegmentFileName = FileName
            
     Case afwFileExtension
             CharPos = InStrRev(FileName, ".")
             If (CharPos > 0) Then FileName = Mid(FileName, CharPos + 1)
             SegmentFileName = FileName
            
     Case afwPathNameSansExtension
             CharPos = InStr(FileName, ".")
             If (CharPos > 0) Then FileName = Left(FileName, CharPos - 1)
             SegmentFileName = FileName
            
     End Select
End Function


